//+------------------------------------------------------------------+
//|                                                  Ultra trend.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "copyleft mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 LimeGreen
#property indicator_color2 Red

//
//
//
//
//

extern int Length      = 12;
extern int Progression = 3;
extern int Sensitivity = 30;
extern int CountBars   = 1000;

//
//
//
//
//

double buffer1[];
double buffer2[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
   return(0);
}

//
//
//
//
//

int start()
{
   int endLength    = Length + Progression * Sensitivity;            
   int counted_bars = IndicatorCounted();
   int i,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
         limit = MathMin(Bars-counted_bars,CountBars);

   //
   //
   //
   //
   //

   for (i=limit; i>=0; i--)
   {
      buffer1[i] = 0.00;
      buffer2[i] = 0.00;
      for (int k = Length; k <= endLength; k += Progression)
         if (iCustom(NULL,0,"HMA",k,100,0,i) > iCustom(NULL,0,"HMA",k,100,0,i+1))
              buffer1[i]++;
         else buffer2[i]++;
   }
   return(0);
}